unit Unit1;

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, db, BufDataset, sqldb, FileUtil, Forms,
  Controls, Graphics, Dialogs, DBGrids, ExtCtrls;

type

  { TForm1 }

  TForm1 = class(TForm)
    BufDataset1: TBufDataset;
    DataSource1: TDataSource;
    DBGrid1: TDBGrid;
    ImageList1: TImageList;
    Panel1: TPanel;
    procedure DBGrid1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure DBGrid1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormCreate(Sender: TObject);
    procedure Panel1DragDrop(Sender, Source: TObject; X, Y: Integer);
    procedure Panel1DragOver(Sender, Source: TObject; X, Y: Integer;
      State: TDragState; var Accept: Boolean);
    procedure Panel1Paint(Sender: TObject);
  private
    FGridDragColumn: TColumn;
  end;

var
  Form1: TForm1;

implementation

{$R *.lfm}

{ TForm1 }

procedure TForm1.FormCreate(Sender: TObject);
var
  i, i2: Integer;
begin
  FGridDragColumn := nil;
  BufDataset1.CreateDataset;
  for i := 0 to 9 do
  begin
    BufDataset1.Insert;
    for i2 := 0 to BufDataset1.FieldCount - 1 do
      BufDataset1.Fields[i2].AsString := 'Item' + IntToStr(i2) + IntToStr(i);
  end;
  BufDataset1.Active := True;
end;

procedure TForm1.DBGrid1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  AColumn: TColumn;
  ARecordOffset: Integer;
  P: TPoint;
begin
  P := DBGrid1.MouseToCell(Point(X, Y));
  if P.y = 0 then
  begin
    DBGrid1.MouseToRecordOffset(X, Y, AColumn, ARecordOffset);
    if Assigned(AColumn) then
      FGridDragColumn := AColumn;
  end;
end;

procedure TForm1.DBGrid1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  FGridDragColumn := nil;
end;

procedure TForm1.Panel1DragDrop(Sender, Source: TObject; X, Y: Integer);
begin
  if (Source is TDBGrid) and Assigned(FGridDragColumn) then
  begin
    FGridDragColumn.SizePriority := 0;
    FGridDragColumn.Width := 0;
  end;
end;

procedure TForm1.Panel1DragOver(Sender, Source: TObject; X, Y: Integer;
  State: TDragState; var Accept: Boolean);
begin
  Accept := Assigned(FGridDragColumn);
end;

procedure TForm1.Panel1Paint(Sender: TObject);
begin
  ImageList1.Draw(Panel1.Canvas,
                 (Panel1.ClientWidth - ImageList1.Width) div 2,
                 (Panel1.ClientHeight - ImageList1.Height) div 2,
                 0);
end;

end.

